=== debian/changelog ===
openvdb (10.0.1-3) unstable; urgency=medium

  * Team upload

  [ Sebastian Ramacher ]
  * debian/control:
    - Drop Priority: optional
    - Bump Standards-Version
  * debian/:
    - Remove no longer necessary lintian overrides
    - Switch to debhelper-compat (= 13)

  [ Adrian Bunk ]
  * Fix FTBFS on riscv64, alpha, sh4, x32 (Closes: #1126909)

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 05 Feb 2026 21:47:03 +0100

openvdb (10.0.1-2.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Disable AX until ported to newer LLVM. (Closes: #1061216)
  * Revert Maintainer change and Ubuntu changelog entries from the previous NMU.
  * Add missing changes from debian/control to debian/control.in.

 -- Adrian Bunk <bunk@debian.org>  Thu, 09 Jan 2025 14:39:36 +0200

openvdb (10.0.1-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix build with -std=c++17. Closes: #1083179.

 -- Matthias Klose <doko@debian.org>  Wed, 08 Jan 2025 16:08:55 +0100

openvdb (10.0.1-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063107

 -- Steve Langasek <vorlon@debian.org>  Fri, 01 Mar 2024 19:17:49 +0000

openvdb (10.0.1-2) unstable; urgency=medium

  * debian/control: Fix dependency of libopenvdb-ax-dev on shared library
    (Closes: #1035454)

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 04 May 2023 23:14:05 +0200

openvdb (10.0.1-1) unstable; urgency=medium

  * New upstream version 10.0.1
  * d/patches: Refresh patches for new upstream

 -- Mathieu Malaterre <malat@debian.org>  Mon, 02 Jan 2023 10:08:14 +0100

openvdb (10.0.0-15) unstable; urgency=medium

  * Upload to unstable

 -- Mathieu Malaterre <malat@debian.org>  Sun, 18 Dec 2022 10:22:49 +0100

openvdb (10.0.0-14) experimental; urgency=medium

  * d/rules: Do not build vdb_tool on mipsel
  * d/rules: Use -O1 on mipsel. Closes: #1026010

 -- Mathieu Malaterre <malat@debian.org>  Wed, 14 Dec 2022 08:46:20 +0100

openvdb (10.0.0-13) experimental; urgency=medium

  * d/rules: i386 seems to also have limited memory
  * d/rules: Add missing `-mxgot` CXXFLAGS for mipsel

 -- Mathieu Malaterre <malat@debian.org>  Fri, 09 Dec 2022 18:26:20 +0100

openvdb (10.0.0-12) experimental; urgency=medium

  * d/rules: Do not use extern template on 32bits
  * d/rules: No parallel job on mipsel

 -- Mathieu Malaterre <malat@debian.org>  Thu, 08 Dec 2022 08:43:11 +0100

openvdb (10.0.0-11) experimental; urgency=medium

  * d/rules: Lower memory requirement on armel
  * d/rules: Lower even more mem requirement on mipsel
  * d/patches: Yet another fix for ax unit-test failure

 -- Mathieu Malaterre <malat@debian.org>  Tue, 06 Dec 2022 08:21:40 +0100

openvdb (10.0.0-10) experimental; urgency=medium

  * d/rules: Fix logic for building AX unit test
  * d/rules: Downgrade opt level to O1 on mipsel
  * d/patches: Yet another pass at fixing unit tests

 -- Mathieu Malaterre <malat@debian.org>  Mon, 05 Dec 2022 08:10:11 +0100
